/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-11 at 20:34:47 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.latitude.model;

/**
 * A Location resource identifies a user's position at a particular time. It may include metadata
 * about the user's position, such as a venue if the location was recorded at the time of a check-
 * in.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Latitude API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Location extends com.google.api.client.json.GenericJson {

  /**
   * Accuracy of the latitude and longitude coordinates, in non-negative meters. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object accuracy;

  /**
   * Unique ID of the Buzz message that corresponds to the check-in associated with this location.
   * Available only for check-in locations. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object activityId;

  /**
   * Altitude of the location, in meters. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object altitude;

  /**
   * Accuracy of the altitude value, in meters. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object altitudeAccuracy;

  /**
   * Direction of travel of the user when this location was recorded. In degrees, clockwise relative
   * to true north. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object heading;

  /**
   * Kind of this item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Latitude of the location, in decimal degrees.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object latitude;

  /**
   * Longitude of the location, in decimal degrees.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object longitude;

  /**
   * Ground speed of the user at the time this location was recorded, in meters per second. Non-
   * negative. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object speed;

  /**
   * Timestamp of the Location Resource, in milliseconds since the epoch (UTC). This is also the
   * Location Resource's unique id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object timestampMs;

  /**
   * Accuracy of the latitude and longitude coordinates, in non-negative meters. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getAccuracy() {
    return accuracy;
  }

  /**
   * Accuracy of the latitude and longitude coordinates, in non-negative meters. Optional.
   * @param accuracy accuracy or {@code null} for none
   */
  public Location setAccuracy(java.lang.Object accuracy) {
    this.accuracy = accuracy;
    return this;
  }

  /**
   * Unique ID of the Buzz message that corresponds to the check-in associated with this location.
   * Available only for check-in locations. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getActivityId() {
    return activityId;
  }

  /**
   * Unique ID of the Buzz message that corresponds to the check-in associated with this location.
   * Available only for check-in locations. Optional.
   * @param activityId activityId or {@code null} for none
   */
  public Location setActivityId(java.lang.Object activityId) {
    this.activityId = activityId;
    return this;
  }

  /**
   * Altitude of the location, in meters. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getAltitude() {
    return altitude;
  }

  /**
   * Altitude of the location, in meters. Optional.
   * @param altitude altitude or {@code null} for none
   */
  public Location setAltitude(java.lang.Object altitude) {
    this.altitude = altitude;
    return this;
  }

  /**
   * Accuracy of the altitude value, in meters. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getAltitudeAccuracy() {
    return altitudeAccuracy;
  }

  /**
   * Accuracy of the altitude value, in meters. Optional.
   * @param altitudeAccuracy altitudeAccuracy or {@code null} for none
   */
  public Location setAltitudeAccuracy(java.lang.Object altitudeAccuracy) {
    this.altitudeAccuracy = altitudeAccuracy;
    return this;
  }

  /**
   * Direction of travel of the user when this location was recorded. In degrees, clockwise relative
   * to true north. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getHeading() {
    return heading;
  }

  /**
   * Direction of travel of the user when this location was recorded. In degrees, clockwise relative
   * to true north. Optional.
   * @param heading heading or {@code null} for none
   */
  public Location setHeading(java.lang.Object heading) {
    this.heading = heading;
    return this;
  }

  /**
   * Kind of this item.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of this item.
   * @param kind kind or {@code null} for none
   */
  public Location setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Latitude of the location, in decimal degrees.
   * @return value or {@code null} for none
   */
  public java.lang.Object getLatitude() {
    return latitude;
  }

  /**
   * Latitude of the location, in decimal degrees.
   * @param latitude latitude or {@code null} for none
   */
  public Location setLatitude(java.lang.Object latitude) {
    this.latitude = latitude;
    return this;
  }

  /**
   * Longitude of the location, in decimal degrees.
   * @return value or {@code null} for none
   */
  public java.lang.Object getLongitude() {
    return longitude;
  }

  /**
   * Longitude of the location, in decimal degrees.
   * @param longitude longitude or {@code null} for none
   */
  public Location setLongitude(java.lang.Object longitude) {
    this.longitude = longitude;
    return this;
  }

  /**
   * Ground speed of the user at the time this location was recorded, in meters per second. Non-
   * negative. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.Object getSpeed() {
    return speed;
  }

  /**
   * Ground speed of the user at the time this location was recorded, in meters per second. Non-
   * negative. Optional.
   * @param speed speed or {@code null} for none
   */
  public Location setSpeed(java.lang.Object speed) {
    this.speed = speed;
    return this;
  }

  /**
   * Timestamp of the Location Resource, in milliseconds since the epoch (UTC). This is also the
   * Location Resource's unique id.
   * @return value or {@code null} for none
   */
  public java.lang.Object getTimestampMs() {
    return timestampMs;
  }

  /**
   * Timestamp of the Location Resource, in milliseconds since the epoch (UTC). This is also the
   * Location Resource's unique id.
   * @param timestampMs timestampMs or {@code null} for none
   */
  public Location setTimestampMs(java.lang.Object timestampMs) {
    this.timestampMs = timestampMs;
    return this;
  }

  @Override
  public Location set(String fieldName, Object value) {
    return (Location) super.set(fieldName, value);
  }

  @Override
  public Location clone() {
    return (Location) super.clone();
  }

}
